/*
 * cfidfsw.c
 *
 * Copyright (c) 2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 *   Natural Language Processing Laboratory,
 *   Japan Advanced Institute of Science and Technology.
 *
 *
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one.  
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 * lexical chainersνϤ򸵤˳ʸνٷ׻򤹤롥
 *
 * query biasedб롥
 *
 */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>

#include "cfidfsw.h"

extern void snw_preparation();
extern struct snword *snw;

extern void main_engine();
extern int query_preparation();

static char *pname;
/* char *mrf;*/
char *dffile;	/* dffile ̾ */
char *qffile;	/* query file ̾ */

static help()
{
        fprintf (stderr, "Posum CL version 1.50 -cfidfsw-");
        fprintf (stderr, " (c) 2000,2001 Hajime Mochizuki\n");
        fprintf (stderr, "usage: %s [options] < chain_file\n", pname);
        fprintf (stderr, "\n");
	fprintf (stderr, "ŪϢ˻ѤǤη(ɤ줫1)\n");
	fprintf (stderr, "  -knp  : KNP-tabѤƺ줿Ϣ\n");
	fprintf (stderr, "  -cha  : ChaSen 2.2.x  -e (default)\n");
	fprintf (stderr, "  -jum  : JUMAN 3.61    -e \n");
	fprintf (stderr, "ŪϢ˻ѤϢξ(ɤ줫1)\n");
	fprintf (stderr, "  -the  : 饹(default)\n");
	fprintf (stderr, "  -co   : ζط\n");
	fprintf (stderr, "  -rep  : Ʊȿ\n");
	fprintf (stderr, "ŪϢνŤդΥ⡼ɻ\n");
        fprintf (stderr, "  -cwm <num> :\n");
        fprintf (stderr, "\t\t0   : Ťդʤ\n");
        fprintf (stderr, "\t\t1   : Ťդ cf (default)\n");
        fprintf (stderr, "\t\t2   : Ťդ cfidf (dffileɬ)\n");
        fprintf (stderr, "\t\t\t-df <file> : -cwm 2λŤդΤdffile\n");
	fprintf (stderr, "Query BiasedΥݡ(defaultǤϥХ򤫤ʤ)\n");
        fprintf (stderr, "  -qf <file>  : Query file\n");
        fprintf (stderr, "  -qwgt <num> : Ťߤ (default=3)\n");
	fprintf (stderr, "ʸĹˤΥ⡼ɻ\n");
        fprintf (stderr, "  -nm <num>  : \n");
        fprintf (stderr, "\t\t0 : ʤ (default)\n");
        fprintf (stderr, "\t\t1 : ñ\n");
        fprintf (stderr, "\t\t2 : ʸкͤ\n");
        fprintf (stderr, "\t\t3 : ʸΥ2/ñ\n");
        fprintf (stderr, "\t\t4 : ñ*-nm_val \n");
        fprintf (stderr, "\t\t\t-nm_val <num> : -nm 4λνŤ (1)\n");
        fprintf (stderr, "\t\t5 : (ñǳ/2)+(ʸкͤǳ)\n");
        fprintf (stderr, "  -h  :  help\n");
        fprintf (stderr, "  -hh :  help2\n");
}

/*
 * use_cha4qb ˤĤƤϡüʻˡΤʤ
 */
static help2()
{
        fprintf (stderr, "\n");
	fprintf (stderr, "ѤŪϢ\n");
        fprintf (stderr, "  -min_chntf <num> : ʾϢǧ뤫(default=1)\n");
        fprintf (stderr, "  -thre_mode <num> : ϢΥˤ­ڤ⡼ɻ\n");
        fprintf (stderr, "\t\t0 : ­ڤꤷʤ (default)\n");
        fprintf (stderr, "\t\t1 : Ϣʿ* -thre_val ʾ\n");
        fprintf (stderr, "\t\t2 : -thre_valʾ\n");
        fprintf (stderr, "\t\t\t-thre_val <num> -thre_mode 0ʳλνŤ߻(0.5)\n");
        fprintf (stderr, "  -chain <num> : chain length thresholdʬ\n");
        fprintf (stderr, "  -gap <num>   : gap lengh thresholdʬ\n");
	fprintf (stderr, "ˤŤդ(defaultǤϽŤդ򤹤)\n");
	fprintf (stderr, "  -wrule <file> : ˤŤߤ򵭽Ҥեλ\n");
	fprintf (stderr, "  -no_pw :         ˤŤդ򤷤ʤ\n");
        fprintf (stderr, "\n");
}

void optchk (argc, argv)
       int   argc;
       char *argv[];
{
        pname = argv[0];
        qwgt=(double)3;
        qb = 0;
        chnw_mode = 1;
        min_chntf = 1;
        thre_mode = 0;
        thre_val  = (double)0.5;
        length_mode = 0;
        /*use_cha=0;*/
        chain_bunbo=100;
        gap_bunbo = 10;
        chain_threshold = 1;
        gap_threshold = 1;
	mrp_type=0;
	chn_type=0;
	norm_mode=0;
	norm_val=(double)1.0;
	no_pw=0;
	mrf = NULL;
	qffile=NULL;
	dffile=NULL;

        argc--, argv++;

        while (argc>0 && *argv[0]=='-') {
                if (!strcmp(argv[0], "-df")) {
                        argc--, argv++;
                        dffile = argv[0];
                } else if (!strcmp(argv[0], "-cwm")) {
                        argc--, argv++;
                        chnw_mode = atoi(argv[0]);
                } else if (!strcmp(argv[0], "-qf")) {
                        argc--, argv++;
                        qb=1;
                        qffile = argv[0];
		/*
                } else if (!strcmp(argv[0], "-use_cha4qb")) {
                        use_cha=1;
		*/
                } else if (!strcmp(argv[0], "-qwgt")) {
                        argc--, argv++;
                        qwgt = atof(argv[0]);
                } else if (!strcmp(argv[0], "-min_chntf")) {
                        argc--, argv++;
                        min_chntf = atoi(argv[0]);
                } else if (!strcmp(argv[0], "-thre_mode")) {
                        argc--, argv++;
                        thre_mode = atoi(argv[0]);
                } else if (!strcmp(argv[0], "-thre_val")) {
                        argc--, argv++;
                        thre_val = atof(argv[0]);
                } else if (!strcmp(argv[0], "-nm")) {
                        argc--, argv++;
                        norm_mode=atoi(argv[0]);
                } else if (!strcmp(argv[0], "-nm_val")) {
                        argc--, argv++;
                        norm_val = atof(argv[0]);
                } else if (!strcmp(argv[0], "-chain")) {
                        argc--, argv++;
                        chain_bunbo = atoi(argv[0]);
                } else if (!strcmp(argv[0], "-gap")) {
                        argc--, argv++;
                        gap_bunbo = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-knp")) {
			mrp_type = 1;
		} else if (!strcmp(argv[0], "-cha")) {
			mrp_type = 0;
		} else if (!strcmp(argv[0], "-jum")) {
			mrp_type = 2;
		} else if (!strcmp(argv[0], "-the")) {
			chn_type = 0;
		} else if (!strcmp(argv[0], "-rep")) {
			chn_type = 0;
		} else if (!strcmp(argv[0], "-co")) {
			chn_type = 1;
		} else if (!strcmp(argv[0], "-no_pw")) {
			no_pw=1;
		} else if (!strcmp(argv[0], "-wrule")) {
			argc--, argv++;
			mrf = argv[0];
                } else if (!strcmp(argv[0], "-h")) {
                        help();
                        exit(1);
                } else if (!strcmp(argv[0], "-hh")) {
                        help();
                        help2();
                        exit(1);
                } else {
                        fprintf (stderr, "Invalid arg: %s\n", argv[0]);
                        help();
                        exit(1);
                }
                argc--, argv++;
        }
}


int main (argc, argv)
    int   argc;
    char *argv[];
{
	int qhsz=HashSize, qentry;
	struct hash_entry *qhtab[HashSize];

	optchk (argc, argv);

	if (chnw_mode==2) {
		if (dffile==NULL) help();
	}
	if (qb==1) {
		if (qffile==NULL) help();
		qentry=query_preparation(qffile, qhtab, qhsz);
	}
	main_engine(qhtab, qhsz, qentry, mrf, dffile);
}
/*

int main_zero (argc, argv) 
    int   argc;
    char *argv[];
{
	int sn, wn, wnum, cdct, ssct, cn, N, df, df0, tf;
	int qhsz=HashSize;
	double acscr;
	struct chain_data *cdat;
	struct sentence *ss;
	struct chn_entry *ce;
	struct hash_entry *qhtab[HashSize];
        struct patrash_files *pf;
        struct patrash_answer_int *intr;
	char buf[BUFSIZ];

        fgets(buf, BUFSIZ, stdin);
	sscanf(buf, "%d %d %d\n", &wn, &sn, &wnum);
	snw_preparation(wn);
	cdct = 30;
	cdat = cal_cdat(cdct);
	ssct = sn+1;
	ss = cal_and_fresh_ss(ssct);
	cn=0, N=0, tf=0, df=1, acscr=(double)0;

	if (chnw_mode==2) {
		if (dffile==NULL) help();
		pf = patrash_preparation(dffile);
		N  = get_num("N", pf);
	}

	if (qb==1) {
		if (qffile==NULL) help();
		qentry=query_preparation(qffile, qhtab, qhsz);
	}

	while(fgets(buf, BUFSIZ, stdin)!=NULL) {
		if (buf[0]=='\0') {
			if (chnw_mode==2 && chn_type==0) {
				df = get_num(snw[0].sense, pf);
			}
			if (tf>=min_chntf) {
				if (cn>=cdct) {
					cdat = ral_cdat(cdat, cdct+10);
					cdct+=10;
				}
				acscr+=calc_cscr(tf,snw,cdat,cn,N,df,qper,chnw_mode);
				cn++;
			}
			tf=0, df=1, qper=(double)1;
		} else {
			snw = fill_snw(buf, snw, tf, chn_type);
			ss  = fill_ss(ss, snw, tf);
			awwct+=ss[snw[tf].sn].wnum;
			if (qb)	if (chk_word_in_hash(snw[tf].word,qhtab,qhsz)) qper=qwgt;

			if (chnw_mode==2 && chn_type!=0) {
				df0 = get_num(snw[tf].sense, pf);
				if (df < df0) df=df0;
			}
			tf++;
		}
	}
	calc_sscr (cdat,cn,ss,acscr);
	sscalcmore(ss, sn, awwct,norm_mode,norm_val);
}
*/
