/*
 * tfidfsw_cha.c
 *
 * Copyright (c) 1998-2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 * Natural Language Processing Laboratory,
 * Japan Advanced Institute of Science and Technology.
 * 
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one. 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 * tfidfĤä ʸХ르ꥺ
 *  ʸ׻
 *  ʸγƸνŤߤtf or tfidfǷ׻­礻롥
 *
 * ϤϥƥȡChaSen 2.2.xˤǲϤԤʤ
  */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <chainers/patrash.h>
#include <chainers/nero.h>
/* #include <chainers/cmn.h>*/
#include <chainers/mrpfil.h>
#include "tfflt.h"
#include "qbnrm.h"

/*#include "chasen.h"*/

extern struct patrash_files* patrash_preparation ();
extern struct patrash_answer_int* tell_patrash_int ();

extern int         chaflt_out_num;
extern int         number_of_words;
extern CHAFLT_OUT* direct_chaflt ();
extern char*       chasen_sparse_tostr ();

extern void chasen_preparation();

extern void sscalcmore();
extern int get_tf_from_hash();

static char *pname;
static int  weight_mode;/* ñνŤդ⡼ 0:no 1:tf 2:tfidf */
static char *dffile;	/* dffile ̾ */
static char *qffile;	/* query file ̾ */
static int qb;
double qwgt;
int N;
/* static int mrp_type;*/
/* static int filtermode;*/
/* char *mrf;*/

static int  norm_mode;	/* ʸĹˤ⡼ */
static double norm_val;	/* Ψ? */

#ifndef HashSize
#define HashSize 1001
#endif

static help()
{
	fprintf (stderr, "Posum CL version 1.50 -tfidfsw_cha-");
	fprintf (stderr, "   (c) 2000,2001 Hajime Mochizuki\n");
	fprintf (stderr, "usage: %s [options] < txtfile\n", pname);
	fprintf (stderr, "\n");
	fprintf (stderr, "FILTER FILE\n");
	fprintf (stderr, "  -rule <filename> : ñꥹȤʤɤ򵭽Ҥfileλ\n");
	fprintf (stderr, "TERM SELECTION\n");
        fprintf (stderr, "  -F <num> :filter mode θʻλ Default=0\n");
        fprintf (stderr, "\t\t 0 . ̾ ư ƻ\n");
        fprintf (stderr, "\t\t 1 . ̾ ---- ƻ\n");
        fprintf (stderr, "\t\t 2 . ̾ ---- ------\n");
        fprintf (stderr, "\t\t 3 . ̾ ư ------\n");
        fprintf (stderr, "\t\t 4 . ---- ư ------\n");
        fprintf (stderr, "\t\t 5 . ---- ư ƻ\n");
        fprintf (stderr, "\t\t 6 . ---- ---- ƻ\n");
	fprintf (stderr, "WEIGHT TYPE\n");
	fprintf (stderr, "  -twm <num> :ñνŤդ⡼ɻ Default=1\n");
	fprintf (stderr, "\t\t0   : Ťդʤ\n");
	fprintf (stderr, "\t\t1   : Ťդ tf\n");
	fprintf (stderr, "\t\t2   : Ťդ tfidf (dffileɬ)\n");
	fprintf (stderr, "  -df <filename> :ŤդΤdffile\n");
	fprintf (stderr, "QUERY-BIASED\n");
	fprintf (stderr, "  -qf <filename> :query biasedΤΥե\n");
	fprintf (stderr, "  -qwgt <num> :query biasedΤνŤߤ Default=3\n");
	fprintf (stderr, "NORMALIZATION\n");
	fprintf (stderr, "  -nm <num> :ʸĹˤ⡼ɻ Default=0\n");
	fprintf (stderr, "\t\t0 : ʤ\n");
	fprintf (stderr, "\t\t1 : ñ\n");
	fprintf (stderr, "\t\t2 : ʸкͤ\n");
	fprintf (stderr, "\t\t3 : ʸΥ2/ñ\n");
	fprintf (stderr, "\t\t4 : ñ*-nm_val \n");
	fprintf (stderr, "\t\t5 : (ñǳ/2)+(ʸкͤǳ)\n");
	fprintf (stderr, "  -nm_val <num> :-nm 4λνŤ Default=1\n");
	fprintf (stderr, "  -h  :help\n");
	fprintf (stderr, "\n");
	exit(1);
}

void optchk (argc, argv)
       int   argc;
       char *argv[];
{
	pname = argv[0];
	weight_mode = 1;
	qwgt=(double)3;
	argc--, argv++;
	qb=0;
	norm_mode = 0;
	norm_val = (double)1;
	mrp_type = 0;/* 0=ChaSen2.2.x˸ */
	filtermode=0;
	mrf = NULL;

	while (argc>0 && *argv[0]=='-') {
		if (!strcmp(argv[0], "-df")) {
			argc--, argv++;
			dffile = argv[0];
		} else if (!strcmp(argv[0], "-twm")) {
			argc--, argv++;
			weight_mode = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-nm")) {
			argc--, argv++;
			norm_mode=atoi(argv[0]);
		} else if (!strcmp(argv[0], "-nm_val")) {
			argc--, argv++;
			norm_val = atof(argv[0]);
		} else if (!strcmp(argv[0], "-qf")) {
			argc--, argv++;
			qb=1;
			qffile = argv[0];
		} else if (!strcmp(argv[0], "-F")) {
			argc--, argv++;
			filtermode=atoi(argv[0]);
		} else if (!strcmp(argv[0], "-rule")) {
			argc--, argv++;
			mrf = argv[0];
		} else if (!strcmp(argv[0], "-qwgt")) {
			argc--, argv++;
			qwgt = atof(argv[0]);
		} else if (!strcmp(argv[0], "-h")) {
			help();
		} else {
			fprintf (stderr, "Invalid arg: %s\n", argv[0]);
			help();
		}
		argc--, argv++;
	}
}

int main (argc, argv)
    int   argc;
    char *argv[];
{
	int  ct, sn, entry, hashsize=HashSize, qhashsize=HashSize;
	int i, j, tf, df, qentry, sct, awwct, allmrp;
	double qper;
	struct sentence *ss, *tp;
	char *cptr, buf[BUFSIZ];
	struct tmpwords *tw, *tmp;
	CHAFLT_OUT *words;
	struct hash_entry *hashtab[HashSize], *qhashtab[HashSize];
	struct patrash_files *pf;
	struct patrash_answer_int *intr;
	FILE *qfile;

	optchk(argc, argv);

	if ((tw=calloc((size_t)30, sizeof(*tw)))==NULL) {
		perror ("calloc for tw");
		exit(1);
	}
	if ((ss=calloc((size_t)31, sizeof(*ss)))==NULL) {
		perror("calloc for ss");
		exit(1);
	}
	sct=31, j=1;
	ct = 30;
	N=0;
	if (weight_mode==2) {
		if (dffile==NULL) help();
		pf = patrash_preparation (dffile);
		intr  = tell_patrash_int ("N", pf->pa, pf->wan);
		if (intr==NULL) {
			fprintf (stderr, "??? dffile is broken??\n");
			exit(1);
		}
		N = intr->num;
		free(intr); intr=NULL;
	}
	sn = 0; allmrp=0;
	chasen_preparation (pname);
	init_hash_f (hashtab, hashsize); 

	if(qb==1) {
		if (qffile==NULL) help();
		if ((qfile=fopen(qffile, "r"))==NULL) {
			fprintf (stderr, "cannot open %s\n", qffile);
			exit(1);
		}
		init_hash_f (qhashtab, qhashsize); 
		while (fgets(buf, BUFSIZ, qfile)!=NULL) {
			cptr = chasen_sparse_tostr (buf);
			words= direct_chaflt(cptr, 0, &allmrp, filtermode, mrp_type, mrf);
			qentry+=tffilter (words, qhashtab, qhashsize);
			chaflt_out_init();
		}
		fclose(qfile);
	}

	i=1,  awwct=0; allmrp=0;
	while (fgets(buf, BUFSIZ, stdin)!=NULL) {
		cptr = chasen_sparse_tostr (buf);
		/*words = direct_chaflt (cptr, sn);*/
		words= direct_chaflt(cptr, sn, &allmrp, filtermode, mrp_type, mrf);
		entry += tffilter (words, hashtab, hashsize);
		if (sn>=ct) {
			if ((tmp=
			     realloc(tw, sizeof(*tw)*(ct+10)))==
			    NULL) {
				perror ("realloc for tw");
				exit(1);
			}
			tw=tmp;
			ct+=10;
		}
		if (i>=sct) {
			if ((tp=realloc(ss, sizeof(*ss)*(sct+10)))==NULL) {
				perror ("malloc for ss");
				exit(1);
			}
			ss=tp;
			sct+=10;
		}
		ss[i].sn = i;
		ss[i].wnum = chaflt_out_num;
		awwct+= ss[i].wnum;
		i++;
		copy_words (tw, words, sn);
		chaflt_out_init();
		sn++;
	}
	for (i=0; i<sn; i++) {
		ss[(i+1)].scr=(double)0;
		for (j=0; j<tw[i].ct; j++) {
			qper=(double)1;
			tf = get_tf_from_hash(tw[i].word[j], hashtab, hashsize);
			if (qb==1)
				if(chk_word_in_hash(tw[i].word[j], 
						    qhashtab, qhashsize)) {
					qper=qwgt;
				}
			
			switch (weight_mode) {
			   case 0:
				ss[(i+1)].scr+=(double)1*qper;
				break;
			   case 1:
				ss[(i+1)].scr+= (double)tf*qper;;
				break;
			   case 2:
				intr=tell_patrash_int(tw[i].word[j],
						      pf->pa,pf->wan);
				df = 1;
				if (intr!=NULL) {
					if (df < intr->num) {
						df = intr->num;
					}
					free(intr); intr=NULL;
				}
				ss[(i+1)].scr += qper * 
				     (double)tf * log((double)N/(double)df);
				break;
			}
		}
		/*printf ("%d %f\n", i+1, ss[(i+1)].scr);*/
	}
	sscalcmore(ss, sn, awwct, norm_mode, norm_val);
}
